local EVENT_MERCHANT_OPEN = "MERCHANT_SHOW"

local repairAllItems = function()
  local repairAllCost, canRepair = GetRepairAllCost()
  if (canRepair and (repairAllCost > 0)) then
    RepairAllItems()
    print("Repaired for", GetCoinTextureString(repairAllCost))
  end
end

local getItemPrice = function(link) 
  return select(11, GetItemInfo(link))
end

local getItemQuality = function(link) 
  return select(3, GetItemInfo(link))
end

local isPoorQuality = function(link)
  return getItemQuality(link) == 0
end

local sellGreyItems = function()
  local totalSold = 0
  local count = 0
  for bag=0,4 do
    for slot=0,GetContainerNumSlots(bag) do
      if (count < 12) then
        local link = GetContainerItemLink(bag, slot)
        if link and isPoorQuality(link) then
          local price = getItemPrice(link)
          if (price > 0) then
            ShowInventorySellCursor()
            UseContainerItem(bag, slot)
            totalSold = totalSold + price
            count = count + 1
          end
        end
      else
        break
      end
    end
  end
  if (totalSold > 0) then
    print("Sold", count, "grey items for", GetCoinTextureString(totalSold))
  end
end

local repairAndSell = function()
  if (not IsShiftKeyDown()) then
    sellGreyItems()
    repairAllItems()
  end
end

local frame = CreateFrame("FRAME", "AuTwoSellFrame");
frame:RegisterEvent(EVENT_MERCHANT_OPEN);
frame:SetScript("OnEvent", repairAndSell);